From 0b6eb1e68290243d439ee330ea8d0b239a5aec69 Mon Sep 17 00:00:00 2001
From: John Crispin <blogic@openwrt.org>
Date: Sun, 27 Jul 2014 09:38:50 +0100
Subject: [PATCH 34/53] NET: multi phy support

Signed-off-by: John Crispin <blogic@openwrt.org>
---
 drivers/net/phy/phy.c |    9 ++++++---
 include/linux/phy.h   |    1 +
 2 files changed, 7 insertions(+), 3 deletions(-)

--- a/drivers/net/phy/phy.c
+++ b/drivers/net/phy/phy.c
@@ -734,7 +734,10 @@ static int phy_check_link_status(struct
 		phy_link_up(phydev);
 	} else if (!phydev->link && phydev->state != PHY_NOLINK) {
 		phydev->state = PHY_NOLINK;
-		phy_link_down(phydev, true);
+		if (!phydev->no_auto_carrier_off)
+			phy_link_down(phydev, true);
+		else
+			phy_link_down(phydev, false);
 	}
 
 	return 0;
@@ -1220,7 +1223,10 @@ void phy_state_machine(struct work_struc
 	case PHY_HALTED:
 		if (phydev->link) {
 			phydev->link = 0;
-			phy_link_down(phydev, true);
+			if (!phydev->no_auto_carrier_off)
+				phy_link_down(phydev, true);
+			else
+				phy_link_down(phydev, false);
 		}
 		do_suspend = true;
 		break;
--- a/include/linux/phy.h
+++ b/include/linux/phy.h
@@ -630,6 +630,7 @@ struct phy_device {
 	unsigned downshifted_rate:1;
 	unsigned is_on_sfp_module:1;
 	unsigned mac_managed_pm:1;
+	unsigned no_auto_carrier_off:1;
 
 	unsigned autoneg:1;
 	/* The most recently read link state */
